Callisto4Bootloader: CMSIS/cmsis_armclang.h File Reference

Callisto4Bootloader

Macros | Functions | Variables
cmsis_armclang.h File Reference

CMSIS compiler armclang (Arm Compiler 6) header file. More...

`#include <arm_compat.h>`

Go to the source code of this file.

## Macros

#define | __ASM __asm
#define | __INLINE __inline
#define | __STATIC_INLINE static __inline
#define | __STATIC_FORCEINLINE __attribute__((always_inline)) static __inline
#define | __NO_RETURN __attribute__((__noreturn__))
#define | __USED __attribute__((used))
#define | __WEAK __attribute__((weak))
#define | __PACKED __attribute__((packed, aligned(1)))
#define | __PACKED_STRUCT struct __attribute__((packed, aligned(1)))
#define | __PACKED_UNION union __attribute__((packed, aligned(1)))
#define | __UNALIGNED_UINT32(x) (((struct T_UINT32 *)(x))->v)
#define | __UNALIGNED_UINT16_WRITE(addr, val) (void)((((struct T_UINT16_WRITE *)(void *)(addr))->v) = (val))
#define | __UNALIGNED_UINT16_READ(addr) (((const struct T_UINT16_READ *)(const void *)(addr))->v)
#define | __UNALIGNED_UINT32_WRITE(addr, val) (void)((((struct T_UINT32_WRITE *)(void *)(addr))->v) = (val))
#define | __UNALIGNED_UINT32_READ(addr) (((const struct T_UINT32_READ *)(const void *)(addr))->v)
#define | __ALIGNED(x) __attribute__((aligned(x)))
#define | __RESTRICT __restrict
#define | __get_FPSCR() ((uint32_t)0U)
| Get FPSCR. More...
#define | __set_FPSCR(x) ((void)(x))
| Set FPSCR. More...
#define | __CMSIS_GCC_OUT_REG(r) "=r" (r)
#define | __CMSIS_GCC_RW_REG(r) "+r" (r)
#define | __CMSIS_GCC_USE_REG(r) "r" (r)
#define | __NOP __builtin_arm_nop
| No Operation. More...
#define | __WFI __builtin_arm_wfi
| Wait For Interrupt. More...
#define | __WFE __builtin_arm_wfe
| Wait For Event. More...
#define | __SEV __builtin_arm_sev
| Send Event. More...
#define | __ISB() __builtin_arm_isb(0xF)
| Instruction Synchronization Barrier. More...
#define | __DSB() __builtin_arm_dsb(0xF)
| Data Synchronization Barrier. More...
#define | __DMB() __builtin_arm_dmb(0xF)
| Data Memory Barrier. More...
#define | __REV(value) __builtin_bswap32(value)
| Reverse byte order (32 bit) More...
#define | __REV16(value) __ROR(__REV(value), 16)
| Reverse byte order (16 bit) More...
#define | __REVSH(value) (int16_t)__builtin_bswap16(value)
| Reverse byte order (16 bit) More...
#define | __BKPT(value) __ASM volatile ("bkpt "#value)
| Breakpoint. More...
#define | __RBIT __builtin_arm_rbit
| Reverse bit order of value. More...

## Functions

struct | __attribute__ ((packed)) T_UINT32
__STATIC_INLINE uint32_t | __get_CONTROL (void)
| Enable IRQ Interrupts. More...
__STATIC_INLINE void | __set_CONTROL (uint32_t control)
| Set Control Register. More...
__STATIC_INLINE uint32_t | __get_IPSR (void)
| Get IPSR Register. More...
__STATIC_INLINE uint32_t | __get_APSR (void)
| Get APSR Register. More...
__STATIC_INLINE uint32_t | __get_xPSR (void)
| Get xPSR Register. More...
__STATIC_INLINE uint32_t | __get_PSP (void)
| Get Process Stack Pointer. More...
__STATIC_INLINE void | __set_PSP (uint32_t topOfProcStack)
| Set Process Stack Pointer. More...
__STATIC_INLINE uint32_t | __get_MSP (void)
| Get Main Stack Pointer. More...
__STATIC_INLINE void | __set_MSP (uint32_t topOfMainStack)
| Set Main Stack Pointer. More...
__STATIC_INLINE uint32_t | __get_PRIMASK (void)
| Get Priority Mask. More...
__STATIC_INLINE void | __set_PRIMASK (uint32_t priMask)
| Set Priority Mask. More...
__STATIC_FORCEINLINE uint32_t | __ROR (uint32_t op1, uint32_t op2)
| Rotate Right in unsigned value (32 bit) More...
__STATIC_FORCEINLINE uint8_t | __CLZ (uint32_t value)
| Count leading zeros. More...
__STATIC_FORCEINLINE int32_t | __SSAT (int32_t val, uint32_t sat)
| Signed Saturate. More...
__STATIC_FORCEINLINE uint32_t | __USAT (int32_t val, uint32_t sat)
| Unsigned Saturate. More...

## Variables

__PACKED_STRUCT | T_UINT16_WRITE { uint16_t v
__PACKED_STRUCT | T_UINT16_READ { uint16_t v
__PACKED_STRUCT | T_UINT32_WRITE { uint32_t v
__PACKED_STRUCT | T_UINT32_READ { uint32_t v

## Detailed Description

CMSIS compiler armclang (Arm Compiler 6) header file.

Version
  V5.1.0

Date
  14. March 2019

Definition in file cmsis_armclang.h.

## Macro Definition Documentation

## ◆ __ALIGNED

#define __ALIGNED | ( |  | x | ) | __attribute__((aligned(x)))

Definition at line 108 of file cmsis_armclang.h.

## ◆ __ASM

#define __ASM __asm

Definition at line 38 of file cmsis_armclang.h.

## ◆ __INLINE

#define __INLINE __inline

Definition at line 41 of file cmsis_armclang.h.

## ◆ __NO_RETURN

#define __NO_RETURN __attribute__((__noreturn__))

Definition at line 50 of file cmsis_armclang.h.

## ◆ __PACKED

#define __PACKED __attribute__((packed, aligned(1)))

Definition at line 59 of file cmsis_armclang.h.

## ◆ __PACKED_STRUCT

#define __PACKED_STRUCT struct __attribute__((packed, aligned(1)))

Definition at line 62 of file cmsis_armclang.h.

## ◆ __PACKED_UNION

#define __PACKED_UNION union __attribute__((packed, aligned(1)))

Definition at line 65 of file cmsis_armclang.h.

## ◆ __RESTRICT

#define __RESTRICT __restrict

Definition at line 111 of file cmsis_armclang.h.

## ◆ __STATIC_FORCEINLINE

#define __STATIC_FORCEINLINE __attribute__((always_inline)) static __inline

Definition at line 47 of file cmsis_armclang.h.

## ◆ __STATIC_INLINE

#define __STATIC_INLINE static __inline

Definition at line 44 of file cmsis_armclang.h.

## ◆ __UNALIGNED_UINT16_READ

#define __UNALIGNED_UINT16_READ | ( |  | addr | ) | (((const struct T_UINT16_READ *)(const void *)(addr))->v)

Definition at line 89 of file cmsis_armclang.h.

## ◆ __UNALIGNED_UINT16_WRITE

#define __UNALIGNED_UINT16_WRITE | ( |  | addr,
|  |  | val
| ) |  | (void)((((struct T_UINT16_WRITE *)(void *)(addr))->v) = (val))

Definition at line 81 of file cmsis_armclang.h.

## ◆ __UNALIGNED_UINT32

#define __UNALIGNED_UINT32 | ( |  | x | ) | (((struct T_UINT32 *)(x))->v)

Definition at line 73 of file cmsis_armclang.h.

## ◆ __UNALIGNED_UINT32_READ

#define __UNALIGNED_UINT32_READ | ( |  | addr | ) | (((const struct T_UINT32_READ *)(const void *)(addr))->v)

Definition at line 105 of file cmsis_armclang.h.

## ◆ __UNALIGNED_UINT32_WRITE

#define __UNALIGNED_UINT32_WRITE | ( |  | addr,
|  |  | val
| ) |  | (void)((((struct T_UINT32_WRITE *)(void *)(addr))->v) = (val))

Definition at line 97 of file cmsis_armclang.h.

## ◆ __USED

#define __USED __attribute__((used))

Definition at line 53 of file cmsis_armclang.h.

## ◆ __WEAK

#define __WEAK __attribute__((weak))

Definition at line 56 of file cmsis_armclang.h.

## Function Documentation

## ◆ __attribute__()

struct __attribute__ | ( | (packed) |  | ) |

Definition at line 71 of file cmsis_armclang.h.

## Variable Documentation

## ◆ T_UINT16_READ

__PACKED_STRUCT T_UINT16_READ { uint16_t v

Definition at line 87 of file cmsis_armclang.h.

## ◆ T_UINT16_WRITE

__PACKED_STRUCT T_UINT16_WRITE { uint16_t v

Definition at line 79 of file cmsis_armclang.h.

## ◆ T_UINT32_READ

__PACKED_STRUCT T_UINT32_READ { uint32_t v

Definition at line 103 of file cmsis_armclang.h.

## ◆ T_UINT32_WRITE

__PACKED_STRUCT T_UINT32_WRITE { uint32_t v

Definition at line 95 of file cmsis_armclang.h.